// things for files and more
rawset(_G, "X_AvailableButtons", {
	["CUSTOM3"] = BT_CUSTOM3,
	["TOSSFLAG"] = BT_TOSSFLAG,
	["FIRENORMAL"] = BT_FIRENORMAL,
	["FIRE"] = BT_ATTACK
})

rawset(_G, "X_Buttons", {
	[BT_CUSTOM1] = "CUSTOM1",
	[BT_CUSTOM2] = "CUSTOM2",
	[BT_CUSTOM3] = "CUSTOM3",
	[BT_USE] = "SPIN",
	[BT_JUMP] = "JUMP",
	[BT_ATTACK] = "ATTACK",
	[BT_FIRENORMAL] = "FIRENORMAL",
	[BT_WEAPONNEXT] = "WEAPONNEXT",
	[BT_WEAPONPREV] = "WEAPONPREV",
	[BT_CAMLEFT] = "CAMLEFT",
	[BT_CAMRIGHT] = "CAMRIGHT"
})

rawset(_G, "X_SetMenuButton", function(p, button)
	if X_AvailableButtons[button]
		p.menuButton = X_AvailableButtons[button]
	end
end)

rawset(_G, "X_ButtonToString", function(button)
	return X_Buttons[button]
end)

rawset(_G, "X_Characters", {
	["sonic"] = true,
	["tails"] = true,
	["knuckles"] = true,
	["amy"] = false,
	["fang"] = false,
	["metalsonic"] = false
})

rawset(_G, "X_BoolToString", function(bool)
	if bool
		return "on"
	else
		return "off"
	end
end)

rawset(_G, "X_BoolToNumString", function(bool)
	if bool
		return "1"
	else
		return "0"
	end
end)

rawset(_G, "X_BoolToNum", function(bool)
	if bool
		return 1
	else
		return 0
	end
end)

rawset(_G, "X_NumToBool", function(num)
	if num >= 1
		return true
	else
		return false
	end
end)

rawset(_G, "X_StringToBool", function(string)
	if string == "1" or string == "on" or string == "true"
		return true
	elseif string == "0" or string == "off" or string == "false"
		return false
	end
end)

local XCharAbilities = "client/xcell/XCharAbilities.dat"
local springflips = "client/xcell/springflips.dat"
local boostmechanic = "client/xcell/boostmechanic.dat"
local xcellhud = "client/xcell/xcellhud.dat"
local camzoomonboost = "client/xcell/camzoomonboost.dat"

addHook("ThinkFrame", do // loads save files
	if consoleplayer and consoleplayer.valid
	and consoleplayer.dropDashAvailable == nil
		local file = io.openlocal(XCharAbilities)
		if file // this is honestly a much better way of doing it
			local value1 = file:read()
			local value2 = file:read()
			local value3 = file:read()
			local value4 = file:read()
			local value5 = file:read()
			local value6 = file:read()
			
			consoleplayer.dropDashAvailable = X_StringToBool(value1)
			consoleplayer.peeloutAvailable = X_StringToBool(value2)
			consoleplayer.launchAvailable = X_StringToBool(value3)
			consoleplayer.walldashAvailable = X_StringToBool(value4)
			consoleplayer.drillAvailable = X_StringToBool(value5)
			consoleplayer.glidedashAvailable = X_StringToBool(value6)
			
			file:close()
		else
			consoleplayer.dropDashAvailable = true
			consoleplayer.peeloutAvailable = true
			consoleplayer.launchAvailable = true
			consoleplayer.walldashAvailable = true
			consoleplayer.drillAvailable = true
			consoleplayer.glidedashAvailable = true
			
			consoleplayer.saveData = {"1","1","1","1","1","1"}
		end
		
		local file2 = io.openlocal(springflips)
        if file2
            local value = file2:read("*n")
			if value == 1
				COM_BufInsertText(consoleplayer, "springflips ".."on")
			else
				COM_BufInsertText(consoleplayer, "springflips ".."off")
			end
			file2:close()
        else
			COM_BufInsertText(consoleplayer, "springflips on")
        end
		
		local file3 = io.openlocal(boostmechanic)
        if file3
            local value = file3:read("*n")
			if value == 1
				COM_BufInsertText(consoleplayer, "boostmechanic ".."on")
			else
				COM_BufInsertText(consoleplayer, "boostmechanic ".."off")
			end
			file3:close()
        else
			COM_BufInsertText(consoleplayer, "boostmechanic on")
        end
		
		local file4 = io.openlocal(xcellhud)
        if file4
            local value = file4:read("*n")
			if value == 1
				COM_BufInsertText(consoleplayer, "xcellhud ".."on")
			else
				COM_BufInsertText(consoleplayer, "xcellhud ".."off")
			end
			file4:close()
        else
			COM_BufInsertText(consoleplayer, "xcellhud on")
        end
		
		local file5 = io.openlocal(camzoomonboost)
        if file5
            local value = file5:read("*n")
			if value == 1
				COM_BufInsertText(consoleplayer, "zoomonboost ".."on")
			else
				COM_BufInsertText(consoleplayer, "zoomonboost ".."off")
			end
			file5:close()
        else
			COM_BufInsertText(consoleplayer, "zoomonboost off")
        end
	end
end)

COM_AddCommand("xcellcommands", function(p, arg)
	CONS_Printf(p, "List of commands:")
	CONS_Printf(p, "")
	CONS_Printf(p, "abilitytoggle")
	CONS_Printf(p, "springflips")
	CONS_Printf(p, "boostmechanic")
	CONS_Printf(p, "xcellhud")
	CONS_Printf(p, "zoomonboost")
	CONS_Printf(p, "")
end)

COM_AddCommand("abilitytoggle", function(p, arg1, arg2)
	if p and p.mo and p.mo.valid
		if arg1 == nil or arg1 == "" or arg1 == "help"
			CONS_Printf(p, "Argument 1: Character to toggle ability of")
			CONS_Printf(p, "Argument 2: Ability to toggle\n")
			CONS_Printf(p, "This will turn on or off any ability of the base characters")
		elseif X_Characters[arg1]
			if arg1 == "sonic"
				if arg2 == "dropdash"
					p.dropDashAvailable = not p.dropDashAvailable
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.dropDashAvailable))
					
					p.saveData[1] = X_BoolToNum(p.dropDashAvailable)
				elseif arg2 == "peelout"
					p.peeloutAvailable = not p.peeloutAvailable
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.peeloutAvailable))
					
					p.saveData[2] = X_BoolToNum(p.peeloutAvailable)
				elseif arg2 == "abilities" or arg2 == nil
					CONS_Printf(p, "Dropdash\nPeelout")
				else
					CONS_Printf(p, "Not an ability!")
				end
			elseif arg1 == "tails"
				if arg2 == "launch"
					p.launchAvailable = not p.launchAvailable
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.launchAvailable))
					
					p.saveData[3] = X_BoolToNum(p.launchAvailable)
				elseif arg2 == "abilities" or arg2 == nil
					CONS_Printf(p, "Launch")
				else
					CONS_Printf(p, "Not an ability!")
				end
			elseif arg1 == "knuckles"
				if arg2 == "walldash"
					p.walldashAvailable = not p.walldashAvailable
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.walldashAvailable))
					
					p.saveData[4] = X_BoolToNum(p.walldashAvailable)
				elseif arg2 == "drill"
					p.drillAvailable = not p.drillAvailable
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.drillAvailable))
					
					p.saveData[5] = X_BoolToNum(p.drillAvailable)
				elseif arg2 == "glidedash"
					p.glidedashAvailable = not p.glidedashAvailable
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.glidedashAvailable))
					
					p.saveData[6] = X_BoolToNum(p.glidedashAvailable)
				elseif arg2 == "abilities" or arg2 == nil
					CONS_Printf(p, "Walldash\nDrill\nGlidedash")
				else
					CONS_Printf(p, "Not an ability!")
				end
			end
			
			local file = io.openlocal(XCharAbilities, "w")
			for i = 1, #p.saveData
				file:write(p.saveData[i].."\n")
			end
			file:close()
		elseif not X_Characters[arg1]
			CONS_Printf(p, "Not a valid character!")
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("springflips", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.springFlips = true
			CONS_Printf(p, "You can now flip on springs")
			if io and p == consoleplayer
				local file = io.openlocal(springflips, "w+")
				file:write(X_BoolToNum(p.springFlips))
				file:close()
			end
		elseif arg == "0" or arg == "off" or arg == "false"
			p.springFlips = false
			CONS_Printf(p, "Spring flips are off")
			if io and p == consoleplayer
				local file = io.openlocal(springflips, "w+")
				file:write(X_BoolToNum(p.springFlips))
				file:close()
			end
		else
			CONS_Printf(p, "Choose whether or not your character can flip on springs")
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("boostmechanic", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.boostMechanic = true
			CONS_Printf(p, "Boost mechanic is on")
			if io and p == consoleplayer
				local file = io.openlocal(boostmechanic, "w+")
				file:write(X_BoolToNum(p.boostMechanic))
				file:close()
			end
		elseif arg == "0" or arg == "off" or arg == "false"
			p.boostMechanic = false
			CONS_Printf(p, "Boost mechanic is off")
			if io and p == consoleplayer
				local file = io.openlocal(boostmechanic, "w+")
				file:write(X_BoolToNum(p.boostMechanic))
				file:close()
			end
		else
			CONS_Printf(p, "Turns on or off the boost mechanic for the mod")
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("xcellhud", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.XCellHud = true
			CONS_Printf(p, "Custom HUD is on")
			if io and p == consoleplayer
				local file = io.openlocal(xcellhud, "w+")
				file:write(X_BoolToNum(p.XCellHud))
				file:close()
			end
		elseif arg == "0" or arg == "off" or arg == "false"
			p.XCellHud = false
			CONS_Printf(p, "Custom HUD is off")
			if io and p == consoleplayer
				local file = io.openlocal(xcellhud, "w+")
				file:write(X_BoolToNum(p.XCellHud))
				file:close()
			end
		else
			CONS_Printf(p, "Toggles the custom HUD for the mod on or off")
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("zoomonboost", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.camZoomOnBoost = true
			CONS_Printf(p, "Camera now zooms in when boost is at max")
			if io and p == consoleplayer
				local file = io.openlocal(camzoomonboost, "w+")
				file:write(X_BoolToNum(p.camZoomOnBoost))
				file:close()
			end
		elseif arg == "0" or arg == "off" or arg == "false"
			p.camZoomOnBoost = false
			CONS_Printf(p, "The camera will not zoom when boost is at max")
			if io and p == consoleplayer
				local file = io.openlocal(camzoomonboost, "w+")
				file:write(X_BoolToNum(p.camZoomOnBoost))
				file:close()
			end
		else
			CONS_Printf(p, "Toggles if the camera will zoom in or not when boost meter is full")
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

// this was so infuriating to make im probably not bringing it back
/*COM_AddCommand("menubutton", function(p, arg) 
	if p and p.mo and p.mo.valid
		if X_AvailableButtons[arg]
			X_SetMenuButton(p, arg)
			CONS_Printf(p, "Menu button set to " + arg)
		elseif arg
			CONS_Printf(p, "Not an available button!")
		elseif arg == nil or arg == "" or arg == "help"
			CONS_Printf(p, "Sets the button to use when opening the settings menu")
			CONS_Printf(p, "\nList of available buttons:" + "\nCUSTOM3\nTOSSFLAG\nFIRENORMAL\nFIRE")
			CONS_Printf(p, "\nCurrent button is: " + X_ButtonToString(p.menuButton))
		end
	end
end)*/