local frac = FRACUNIT

rawset(_G, "X_AddMenuSubOption", function(p, name, description, bool, basevalue, startvalue, maxvalue, inc)
	table.insert(p.suboptions, {
		xname = name, 
		xdescription = description, 
		xbool = bool, 
		xbasevalue = basevalue, 
		xstartvalue = startvalue, 
		xmaxvalue = maxvalue, 
		xinc = inc
	})
end)

rawset(_G, "X_RemoveSubOptions", function(p)
	p.suboptions = {}
end)

rawset(_G, "X_UpdateMenu", function(p)
	if p.options[p.scurSel] == "XCell"
		p.suboptions = {
			{
				name = "Momentum Toggle", 
				description = "If false, momentum is toggled off", 
				bool = true, 
				basevalue = p.XMomentum
			},
			{
				name = "Boost Mechanic", 
				description = "If false, the boost mechanic will be turned off", 
				bool = true, 
				basevalue = p.boostMechanic
			}
		}
	elseif p.options[p.scurSel] == "Character"
		p.suboptions = {
			{
				name = "Sonic Dropdash", 
				description = "Toggles Sonic's Dropdash", 
				bool = true, 
				basevalue = p.dropdashAvailable
			},
			{
				name = "Sonic Peelout", 
				description = "Toggles Sonic's Peelout", 
				bool = true, 
				basevalue = p.peeloutAvailable
			},
			{
				name = "Tails Launch", 
				description = "Toggles Tails' launch ability", 
				bool = true, 
				basevalue = p.launchAvailable
			},
			{
				name = "Knuckles Walldash", 
				description = "Toggles Knuckles' Walldash", 
				bool = true, 
				basevalue = p.walldashAvailable
			},
			{
				name = "Knuckles Glide Dash", 
				description = "Toggles Knuckles' Glide Dash", 
				bool = true, 
				basevalue = p.glidedashAvailable
			}
		}
	elseif p.options[p.scurSel] == "Other"
		p.suboptions = {
			{
				name = "Spring Flips", 
				description = "If true, you can flip hitting springs", 
				bool = true, 
				basevalue = p.springFlips
			}
		}
	end
end)

rawset(_G, "X_UpdateValues", function(p) // i guess i gotta do this to make it work
	if p.options[p.scurSel] == "XCell"
		if p.XMomentum ~= p.suboptions[1].basevalue then p.XMomentum = p.suboptions[1].basevalue end
		if p.boostMechanic ~= p.suboptions[2].basevalue then p.boostMechanic = p.suboptions[2].basevalue end
	elseif p.options[p.scurSel] == "Character"
		if p.dropdashAvailable ~= p.suboptions[1].basevalue then p.dropdashAvailable = p.suboptions[1].basevalue end
		if p.peeloutAvailable ~= p.suboptions[2].basevalue then p.peeloutAvailable = p.suboptions[2].basevalue end
		if p.launchAvailable ~= p.suboptions[3].basevalue then p.launchAvailable = p.suboptions[3].basevalue end
		if p.walldashAvailable ~= p.suboptions[4].basevalue then p.walldashAvailable = p.suboptions[4].basevalue end
		if p.glidedashAvailable ~= p.suboptions[5].basevalue then p.glidedashAvailable = p.suboptions[5].basevalue end
	elseif p.options[p.scurSel] == "Other"
		if p.springFlips ~= p.suboptions[1].basevalue then p.springFlips = p.suboptions[1].basevalue end
	end
end)

addHook("PreThinkFrame", function() // for controls
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) return end
		
		// buttons
		if not (p.cmd.buttons & p.menuButton) then
			p.menuready = true
			p.menu = false
		elseif p.menuready then
			p.menu = true
			p.menuready = false
		else
			p.menu = false
		end
		
		if p.cmd.forwardmove > 0
			p.fbutton = true
		else
			p.fbutton = false
		end
		
		if p.cmd.forwardmove < 0
			p.bbutton = true
		else
			p.bbutton = false
		end
		
		if p.cmd.sidemove > 0
			p.rbutton = true
		else
			p.rbutton = false
		end
		
		if p.cmd.sidemove < 0
			p.lbutton = true
		else
			p.lbutton = false
		end
		
		// button press
		if not p.fbutton then
			p.fbready = true
			p.fb = false
		elseif p.fbready then
			p.fb = true
			p.fbready = false
		else
			p.fb = false
		end
		
		if not p.bbutton then
			p.bbready = true
			p.bb = false
		elseif p.bbready then
			p.bb = true
			p.bbready = false
		else
			p.bb = false
		end
		
		if not p.rbutton then
			p.rbready = true
			p.rb = false
		elseif p.rbready then
			p.rb = true
			p.rbready = false
		else
			p.rb = false
		end
		
		if not p.lbutton then
			p.lbready = true
			p.lb = false
		elseif p.lbready then
			p.lb = true
			p.lbready = false
		else
			p.lb = false
		end
		
		/* open menu (i fucking hate coding this so no more)
		if p.menu
		and not p.XCellMenuOpen
			p.XCellMenuOpen = true
		elseif p.menu
		and p.XCellMenuOpen
			p.XCellMenuOpen = false
		end*/
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) return end
		
		if p.lockPlayer
			p.powers[pw_nocontrol] = 1
			p.powers[pw_flashing] = 100
		end
		
		if p.XCellMenuOpen
			// turn off controls temporarily
			p.lockPlayer = true
			
			// current selection
			if p.fb
				S_StartSound(p.mo, sfx_menu1)
				p.fcurSel = $ - 1
			end
			
			if p.bb
				S_StartSound(p.mo, sfx_menu1)
				p.fcurSel = $ + 1
			end
			
			if p.rb
				S_StartSound(p.mo, sfx_menu1)
				if p.fcurSel == 0 then p.scurSel = $ + 1 end
			end
			
			if p.lb
				S_StartSound(p.mo, sfx_menu1)
				if p.fcurSel == 0 then p.scurSel = $ - 1 end
			end
			
			// selection stuff
			if p.scurSel > #p.options
				p.scurSel = 1
			elseif p.scurSel < 1
				p.scurSel = #p.options
			end
			
			if p.fcurSel > #p.suboptions
				p.fcurSel = 0
			elseif p.fcurSel < 0
				p.fcurSel = #p.suboptions
			end
			
			// actual stuff
			p.menustatename = p.options[p.scurSel]
			p.menustate = p.scurSel // i dont think i even used this
		end
		
		//X_UpdateMenu(p)
		//X_UpdateValues(p)
		
		if not p.XCellMenuOpen
		and p.lockPlayer 
			p.powers[pw_flashing] = 40
			p.lockPlayer = false
		end
		
		if not p.menubarpos or (p.menubarpos and (p.menubarpos > 16))
			p.menubarpos = 1
		else
			p.menubarpos = $+1
		end
		
		for i in ipairs(p.suboptions)
			if i == p.fcurSel
				if p.rb or p.lb
					p.suboptions[i].basevalue = not p.suboptions[i].basevalue
				end
			end
		end
		
		p.currentPortrait = "SONIC&TAILSP"
	end
end)

// v.draw(10, 10, v.cachePatch("SONIC&TAILSP"))

hud.add(function(v, p)
	if p.nightstime then return end
	
	if p.XCellMenuOpen
		v.drawFill(0, 0, 600, 500, 31|V_SNAPTOTOP|V_SNAPTOLEFT)
		
		v.draw(110, 80, v.cachePatch(p.currentPortrait), V_SNAPTOTOP|V_SNAPTOLEFT)
	
		v.drawScaled(32*frac, (p.menubarpos*frac)-16*frac, frac, v.cachePatch("MENUBARS"), V_SNAPTOLEFT|V_SNAPTOTOP, v.getColormap(p.mo.skin, p.mo.color))
		v.drawFill(-10, -100, 42, 1000, skincolors[p.mo.color].ramp[7]|V_SNAPTOLEFT)
		
		v.drawScaled(288*frac, ((p.menubarpos*frac)*-1), frac, v.cachePatch("MENUBARS"), V_SNAPTORIGHT|V_SNAPTOTOP|V_FLIP, v.getColormap(p.mo.skin, p.mo.color))
		v.drawFill(288, -100, 42, 1000, skincolors[p.mo.color].ramp[7]|V_SNAPTORIGHT)
		
		local statecolor = 0
		
		if p.fcurSel == 0
			statecolor = V_YELLOWMAP
		else
			statecolor = 0
		end
		
		v.drawString(160, 30, p.menustatename, statecolor, "center")
		
		for i = 1, #p.suboptions
			local color = 0
			
			if i == p.fcurSel
				color = V_YELLOWMAP
			else
				color = 0
			end
			
			v.drawString(160, 90+(i*8), p.suboptions[i].name + ": " + p.suboptions[i].basevalue, V_ALLOWLOWERCASE|color, "center")
			
			if i == p.fcurSel
				v.drawString(160, 190, p.suboptions[i].description, V_ALLOWLOWERCASE, "center")
			end
		end
	end
end)