local frac = FRACUNIT

addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) then return end
		
		if P_IsPlayerXCellCharacter(p) and p.XCellHud
			hud.disable("lives")
		else
			hud.enable("lives")
		end
		
		if p.XCellCharacter == nil
			p.XCellCharacter = false
		end
		
		if XCellCharacters[p.mo.skin]
			p.XCellCharacter = true
		end
		
		if not (p.charflags & SF_SUPER) -- super for all
			p.charflags = $1|SF_SUPER
		end
		
		-- spring spin i think (used spring front flip script by Demnyx Onyxfur on mb for reference.)
		if P_PlayerInPain(p) -- can you flip or nah
		or P_IsObjectOnGround(p.mo)
		or (p.pflags & PF_JUMPED)
		or (p.pflags & PF_THOKKED)
		or (p.pflags & PF_SPINNING)
		or (mapheaderinfo[gamemap].typeoflevel == TOL_NIGHTS)
		or p.playerstate == PST_DEAD
		or p.powers[pw_carry] ~= CR_NONE
		or p.climbing >= 1
			p.canflip = false
		else
			p.canflip = true
		end
			
		if p.springFlips
			if p.canflip
				if p.mo.z/frac > ((p.mo.floorz + (p.mo.height))/frac)+300
					p.aboutToFlip = true
				else
					p.aboutToFlip = false
				end
				
				if p.aboutToFlip 
					p.fallingCheck = 1
				
					if p.mo.momz > -5*frac
					and p.mo.momz < 5*frac
						p.flipState = 1
					else
						p.flipState = 0
					end
				end
				
				if p.mo.momz > -1*frac
					p.fallingCheck = 0
				end
				
				if p.fallingCheck == 1
					p.flipState = 0
				end
				
				if not p.aboutToFlip
				and p.flipState == 1
					p.flipState = 2
				end
				
				if p.flipState == 2
					p.flipTime = $ + 1
				end
				
				if p.flipTime > 0
					p.mo.state = S_PLAY_ROLL
				end
				
				if p.flipTime >= 10
					p.flipState = 0
				end
				
				if p.flipState == 0
					if p.mo.momz < 0
						p.mo.state = S_PLAY_FALL
					elseif p.mo.momz > 0
						p.mo.state = S_PLAY_SPRING
					end
					
					p.flipTime = 0
				end
				
				if p.flipState == 1
					p.mo.state = S_PLAY_ROLL
				end
			end
		else
			if p.canFlip
				if p.mo.momz < 0
					p.mo.state = S_PLAY_FALL
				elseif p.mo.momz > 0
					p.mo.state = S_PLAY_SPRING
				end
			end
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if (p and p.mo and p.mo.valid)
		p.canflip = false
		p.aboutToFlip = false
		p.flipState = 0 // 0 = fall/launch, 1 = rolling, 2 = failsafe
		p.flipTime = 0 // timer for failsafe
		p.fallingCheck = 1 // checks if your falling
	end
end)

rawset(_G, "XCellCharacters", {
	["sonic"] = true,
	["tails"] = true,
	["knuckles"] = true,
	["amy"] = true,
	["fang"] = true,
	["metalsonic"] = true
})

rawset(_G, "P_IsPlayerXCellCharacter", function(p)
	if p.XCellCharacter
		return true
	else
		return false
	end
end)

local posx = hudinfo[HUD_LIVES].x - 50
local posy = hudinfo[HUD_LIVES].y
local posx2 = posx + 42
local posy2 = posy - 12
local namelength = 0
local iconname = ""

hud.add(function(v, p) // hud
	if p.nightstime or not P_IsPlayerXCellCharacter(p) or not p.XCellHud then return end
	
	namelength = string.len(skins[p.mo.skin].hudname)*8
	
	if p.mo.skin == "sonic" and p.powers[pw_super]
		iconname = "SUPERSONIC"
	else
		iconname = string.upper(p.mo.skin)
	end
	
	if (p and p.mo and p.mo.valid)
		if p.boostMechanic
			v.draw(posx2, posy2, v.cachePatch("BOOST"+tostring(p.boostLevel)), V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(p.mo.skin, p.mo.color))
		else
			v.draw(posx2, posy2, v.cachePatch("NOBOOST"), V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(p.mo.skin, p.mo.color))
		end
		v.draw(posx2, posy2, v.cachePatch(iconname), V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(p.mo.skin, p.mo.color))
		
		v.drawString(posx, posy-10, string.upper(skins[p.mo.skin].hudname), V_YELLOWMAP)
		v.draw(posx+namelength+5, posy-10, v.cachePatch("STLIVEX"), nil, v.getColormap(p.mo.skin, SKINCOLOR_WHITE))
		v.drawNum(posx+namelength+35, posy-10, p.lives, V_YELLOWMAP)
	end
end)

