local varcheck = false

rawset(_G, "X_SetupPlayerVariables", function(p)
	if not varcheck
		// sonic
		// p.dropDashAvailable = true
		p.dropdashTimer = 0 // dropdash timer
		p.dropCooldown = 10 // time before you do dropdash
		
		// p.peeloutAvailable = true
		p.peelTime = 0 // peelout timer
		p.peelStart = false // peelout in stasis
		p.peelingOut = false // peelout active
		p.canPeel = false // can you peelout?
		
		// tails
		// p.launchAvailable = true
		p.launched = false // launch active
		
		// knuckles
		// p.walldashAvailable = true
		p.walldash = false // walldash active
		p.walltime = 0 // timer for walldash
		
		// p.drillAvailable = true
		p.drilling = false // drill active
		p.drilltime = 0 // drill timer
		
		// p.glidedashAvailable = true
		p.dash = false // dash active
		
		// boost
		// p.boostMechanic = true
		
		p.boostTime = 0
		p.boostLevel = 0
		p.boostCap = 105 // 105 instead of 100 because itll replay the dash sound over and over
		p.justLostBoost = false
		p.lostBoot = false
		
		// menu stuff
		p.menuButton = BT_CUSTOM3
		
		p.fbutton = false
		p.bbutton = false
		p.rbutton = false
		p.lbutton = false
		
		p.fcurSel = 0
		p.scurSel = 1
		
		p.options = {"XCell", "Character", "Other"}
		p.suboptions = {}
		
		p.menustate = 0
		p.menustatename = ""
		
		// more stuff
		// p.springFlips = true
		// p.XCellHud = true
		// p.camZoomOnBoost = false
		
		// save data
		p.saveData = {}
		
		// varible check done!
		varcheck = true
	end
end)

rawset(_G, "X_ResetPlayerVariables", function(p) // just incase
	varcheck = false
	X_SetupPlayerVariables(p)
end)

freeslot(
	"SPR2_DRPD", 
	"S_PLAY_DROP",
	"SPR2_DRIL",
	"S_PLAY_DRILL"
)

states[S_PLAY_DROP] = {
	sprite = SPR_PLAY,
	frame = SPR2_DRPD|FF_ANIMATE,
	tics = -1,
	var1 = 2,
	var2 = 2,
	nextstate = S_PLAY_DROP
}

states[S_PLAY_DRILL] = {
	sprite = SPR_PLAY,
	frame = SPR2_DRIL|FF_ANIMATE,
	tics = -1,
	var1 = 2,
	var2 = 2,
	nextstate = S_PLAY_DRILL
}

// from peelout script by MotdSpork
freeslot(
	"S_PLAY_PEEL1", 
	"S_PLAY_PEEL2", 
	"S_PLAY_PEEL3", 
	"S_PLAY_PEEL4", 
	"S_PLAY_PWALK1", 
	"S_PLAY_PWALK2", 
	"S_PLAY_PWALK3", 
	"S_PLAY_PWALK4", 
	"S_PLAY_PWALK5", 
	"S_PLAY_PWALK6", 
	"S_PLAY_PWALK7", 
	"S_PLAY_PWALK8", 
	"S_PLAY_PWALK9", 
	"S_PLAY_PWALK10", 
	"S_PLAY_PWALK11", 
	"S_PLAY_PWALK12", 
	"S_PLAY_PWALK13", 
	"S_PLAY_PWALK14", 
	"S_PLAY_PWALK15", 
	"S_PLAY_PWALK16"
)

states[S_PLAY_PWALK1] = {SPR_PLAY, SPR2_WALK1, 4, nil, 0, 0, S_PLAY_PWALK2}
states[S_PLAY_PWALK2] = {SPR_PLAY, SPR2_WALK2, 4, nil, 0, 0, S_PLAY_PWALK3}
states[S_PLAY_PWALK3] = {SPR_PLAY, SPR2_WALK3, 4, nil, 0, 0, S_PLAY_PWALK4}
states[S_PLAY_PWALK4] = {SPR_PLAY, SPR2_WALK4, 3, nil, 0, 0, S_PLAY_PWALK5}
states[S_PLAY_PWALK5] = {SPR_PLAY, SPR2_WALK5, 3, nil, 0, 0, S_PLAY_PWALK6}
states[S_PLAY_PWALK6] = {SPR_PLAY, SPR2_WALK6, 3, nil, 0, 0, S_PLAY_PWALK7}
states[S_PLAY_PWALK7] = {SPR_PLAY, SPR2_WALK7, 2, nil, 0, 0, S_PLAY_PWALK8}
states[S_PLAY_PWALK8] = {SPR_PLAY, SPR2_WALK8, 2, nil, 0, 0, S_PLAY_PWALK9}
states[S_PLAY_PWALK9] = {SPR_PLAY, SPR2_WALK1, 2, nil, 0, 0, S_PLAY_PWALK10}
states[S_PLAY_PWALK10] = {SPR_PLAY, SPR2_WALK2, 1, nil, 0, 0, S_PLAY_PWALK11}
states[S_PLAY_PWALK11] = {SPR_PLAY, SPR2_WALK3, 1, nil, 0, 0, S_PLAY_PWALK12}
states[S_PLAY_PWALK12] = {SPR_PLAY, SPR2_WALK4, 1, nil, 0, 0, S_PLAY_PWALK13}
states[S_PLAY_PWALK13] = {SPR_PLAY, SPR2_WALK5, 1, nil, 0, 0, S_PLAY_PWALK14}
states[S_PLAY_PWALK14] = {SPR_PLAY, SPR2_WALK6, 1, nil, 0, 0, S_PLAY_PWALK15}
states[S_PLAY_PWALK15] = {SPR_PLAY, SPR2_WALK7, 1, nil, 0, 0, S_PLAY_PWALK16}
states[S_PLAY_PWALK16] = {SPR_PLAY, SPR2_WALK8, 1, nil, 0, 0, S_PLAY_PEEL1}
states[S_PLAY_PEEL1] = {SPR_PLAY, SPR2_DASH_1, 1, nil, 0, 0, S_PLAY_PEEL2}
states[S_PLAY_PEEL2] = {SPR_PLAY, SPR2_DASH_2, 1, nil, 0, 0, S_PLAY_PEEL3}
states[S_PLAY_PEEL3] = {SPR_PLAY, SPR2_DASH_3, 1, nil, 0, 0, S_PLAY_PEEL4}
states[S_PLAY_PEEL4] = {SPR_PLAY, SPR2_DASH_4, 1, nil, 0, 0, S_PLAY_PEEL1}

freeslot(
	"sfx_drop",
	"sfx_drop2",
	"sfx_bost",
	"sfx_bost2",
	"sfx_bost3",
	"sfx_peel",
	"sfx_chrg",
	"sfx_rerol",
	"S_BRING",
	"SPR_BRIN",
	"MT_BRING"
)

mobjinfo[MT_BRING] = {
	spawnstate = S_BRING,
	flags = MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_BRING] = {
	sprite = SPR_BRIN,
	frame = TR_TRANS40|FF_PAPERSPRITE|A
}

sfxinfo[sfx_drop].caption = "Dropdash"
sfxinfo[sfx_drop2].caption = "Dropdash Release"
sfxinfo[sfx_bost].caption = "Hyper Ring"
sfxinfo[sfx_bost2].caption = "Hyper Ring (Pitched Up)"
sfxinfo[sfx_bost3].caption = "Hyper Ring (Pitched Up)"
sfxinfo[sfx_chrg].caption = "Peelout Charge"
sfxinfo[sfx_peel].caption = "Peelout Release"
sfxinfo[sfx_rerol].caption = "Reroll"