local frac = FRACUNIT

addHook("PlayerThink", function(p)
	if p.mo.skin == "sonic"
		// dropdash
		if (p.cmd.buttons & BT_USE) // actual dropdash
		and not p.nightstime
		and P_IsObjectOnGround(p.mo) 
		and (p.mo.eflags & MFE_JUSTHITFLOOR)
		and not P_PlayerInPain(p)
		and p.playerstate ~= PST_DEAD
		and p.dropCooldown == 0
		and p.dropDashAvailable
			if p.powers[pw_super]
				P_StartQuake(45*frac, 2)
				P_NukeEnemies(p.mo, p.mo, 600*frac)
				P_InstaThrust(p.mo, p.mo.angle, p.speed + 30*frac)
				S_StartSound(p.mo, sfx_peel)
				P_SpawnSkidDust(p, 15*frac)
			else
				P_InstaThrust(p.mo, p.mo.angle, p.speed + 20*frac)
				S_StartSound(p.mo, sfx_drop2)
				P_SpawnSkidDust(p, 15*frac)
			end
			p.mo.state = S_PLAY_ROLL
			p.pflags = $1|PF_SPINNING
		end
		
		if (p.cmd.buttons & BT_USE)
		and not p.nightstime
		and not P_IsObjectOnGround(p.mo)
		and p.dropCooldown > 0 
		and p.dropDashAvailable
			p.dropCooldown = $ - 1
		end
		
		if (p.cmd.buttons & BT_USE) // rolls you in a ball to get ready for dropdash
		and not p.nightstime
		and not P_IsObjectOnGround(p.mo)
		and not P_PlayerInPain(p)
		and p.playerstate ~= PST_DEAD
		and p.dropCooldown == 0
		and p.dropDashAvailable
			p.mo.state = S_PLAY_DROP
			p.pflags = $1|PF_JUMPED|PF_THOKKED
			p.dropdashTimer = $ + 1
			//X_SpawnGhostTrail(p, frac/3, true)
		else
			p.dropdashTimer = 0
		end
		
		if not (p.cmd.buttons & BT_USE) // changes state back to roll
		and p.mo.state == S_PLAY_DROP
			p.mo.state = S_PLAY_ROLL
		end
		
		if P_IsObjectOnGround(p.mo) // resets timer
			p.dropdashTimer = 0
			p.dropCooldown = 10
		end
		
		if p.dropdashTimer == 1 // sfx
			S_StartSound(p.mo, sfx_drop)
		end
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid and p.mo.skin == "sonic") then return end
		
		// peelout (this might be difficult i remember it not working last time)
		if P_IsObjectOnGround(p.mo) // checks if you can peelout
		and p.playerstate ~= PST_DEAD
		and p.speed <= 5*frac
		and not p.exiting
		and not p.nightstime
		and p.peeloutAvailable
			p.canPeel = true
		else
			p.canPeel = false
		end
		
		if (p.cmd.buttons & BT_CUSTOM1) // makes you stand still
		and p.canPeel
			p.pflags = $1|PF_STASIS
			p.peelStart = true
			p.peelTime = $ + 1
			p.speed = 0
		end
		
		if (p.cmd.buttons & BT_JUMP) // if you jump it takes you out
		and p.peelStart
			p.pflags = $1 & ~PF_STASIS
			p.canPeel = false
			p.peelStart = false
			p.peelTime = 0
		end
		
		if p.peelTime > 50 // cap
			p.peelTime = 50
		end
		
		if p.peelTime == 1 // starting sfx
			S_StartSound(p.mo, sfx_chrg)
		end
		
		if not (p.cmd.buttons & BT_CUSTOM1) // launch
		and not p.exiting
		and p.peelTime > 15
		and not p.peelingOut
		and p.peelStart
			if p.powers[pw_super]
				if p.powers[pw_underwater]
					P_InstaThrust(p.mo, p.mo.angle, (p.peelTime*(frac+frac/2)) - frac/3)
				else
					P_InstaThrust(p.mo, p.mo.angle, p.peelTime*(frac+frac/2))
				end
			else
				if p.powers[pw_underwater]
					P_InstaThrust(p.mo, p.mo.angle, (p.peelTime*(frac+frac/4)) - frac/3)
				else
					P_InstaThrust(p.mo, p.mo.angle, p.peelTime*(frac+frac/4))
				end
			end
			S_StartSound(p.mo, sfx_peel)
			p.pflags = $1 & ~PF_STASIS
			p.peelingOut = true
			p.peelStart = false
			p.peelTime = 0
		end
		
		if not (p.cmd.buttons & BT_CUSTOM1) // reset peeltime
		or p.exiting
			p.peelTime = 0
		end
		
		if p.peelingOut // turn it off instantly
			p.peelingOut = false
		end
		
		if p.speed > 60*frac // dash anim
			if p.mo.state == S_PLAY_RUN
				p.mo.state = S_PLAY_DASH
			end
		else
			if p.mo.state == S_PLAY_DASH
				p.mo.state = S_PLAY_RUN
			end
		end
		
		if p.speed > 0 // change the anim
		and (p.mo.state == S_PLAY_PEEL1 
		or p.mo.state == S_PLAY_PEEL2 
		or p.mo.state == S_PLAY_PEEL3 
		or p.mo.state == S_PLAY_PEEL4)
			p.mo.state = S_PLAY_DASH
		end
		
		if p.peelTime <= 35 and p.peelTime > 0 // peelout anim (from peelout script by MotdSpork)
			if not (p.mo.state >= S_PLAY_PWALK1)
			and (p.mo.state <= S_PLAY_PWALK16)
				p.mo.state = S_PLAY_PWALK1
			end
		elseif p.peelTime > 35
			if not ((p.mo.state >= S_PLAY_PEEL1) and (p.mo.state <= S_PLAY_PEEL4))
			or ((p.mo.state >= S_PLAY_PWALK1) and (p.mo.state <= S_PLAY_PWALK16))
				p.mo.state = S_PLAY_PEEL1
			end
		end
		
		if p.peelTime >= 10
			P_SpawnSkidDust(p, 15*frac)
		end
		
		if (p.mo.state == S_PLAY_PWALK1 // WHY
		or p.mo.state == S_PLAY_PWALK2 
		or p.mo.state == S_PLAY_PWALK3 
		or p.mo.state == S_PLAY_PWALK4
		or p.mo.state == S_PLAY_PWALK5 
		or p.mo.state == S_PLAY_PWALK6 
		or p.mo.state == S_PLAY_PWALK7
		or p.mo.state == S_PLAY_PWALK8 
		or p.mo.state == S_PLAY_PWALK9 
		or p.mo.state == S_PLAY_PWALK10
		or p.mo.state == S_PLAY_PWALK11 
		or p.mo.state == S_PLAY_PWALK12 
		or p.mo.state == S_PLAY_PWALK13
		or p.mo.state == S_PLAY_PWALK14 
		or p.mo.state == S_PLAY_PWALK15 
		or p.mo.state == S_PLAY_PWALK16)
		and p.peelTime == 0
		and p.speed == 0
			S_StopSoundByID(p.mo, sfx_chrg)
			p.mo.state = S_PLAY_STND
		end
	end
end)

// code base by clairebun because apparently i fuckking suck at coding thoks
addHook("AbilitySpecial", function(p)
	if p.mo.skin != "sonic"
		return 
	end
	if p.pflags&PF_THOKKED
		return true
	end
	local actionspd = FixedMul(p.mo.scale, p.actionspd)
	if p.mo.eflags & MFE_UNDERWATER
		actionspd = $/2
	end
	P_InstaThrust(p.mo, p.mo.angle, actionspd)
	if p.powers[pw_super]
		P_SetObjectMomZ(p.mo, p.speed/6 + 6*frac, false)
	else
		P_SetObjectMomZ(p.mo, p.speed/6 + 2*frac, false)
	end
	P_SpawnThokMobj(p)
	S_StartSound(p.mo, sfx_thok)
	p.pflags = $|PF_THOKKED 
	return true
end)

