local frac = FRACUNIT

addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid and p.mo.skin == "tails") then return end
		// cancel flight
		if p.c1
		and not P_IsObjectOnGround(p.mo)
		and (p.mo.state == S_PLAY_FLY or p.mo.state == S_PLAY_SWIM or p.mo.state == S_PLAY_FLY_TIRED)
			P_SetObjectMomZ(p.mo, 3*frac, false)
			S_StartSound(nil, sfx_rerol, p)
			p.mo.state = S_PLAY_ROLL
			p.pflags = $1|PF_THOKKED|PF_JUMPED
		end
		
		// launch
		if p.c2
		and not P_IsObjectOnGround(p.mo)
		and (p.mo.state == S_PLAY_FLY or p.mo.state == S_PLAY_SWIM or p.mo.state == S_PLAY_FLY_TIRED)
		and p.launchAvailable
			P_SetObjectMomZ(p.mo, 5*frac, false)
			P_InstaThrust(p.mo, p.mo.angle, p.speed + 5*frac)
			S_StartSound(nil, sfx_zoom, p)
			p.mo.state = S_PLAY_FALL
			p.pflags = $1|PF_THOKKED
			p.launched = true
		end
		
		if p.mo.state == S_PLAY_FLY or p.mo.state == S_PLAY_SWIM
			if (p.cmd.buttons & BT_JUMP)
				if p.mo.momz < 8*frac
					P_SetObjectMomZ(p.mo, p.mo.momz+(frac/2), false)
				end
			end
			
			if (p.cmd.buttons & BT_USE)
				if p.mo.momz > -10*frac
					P_SetObjectMomZ(p.mo, p.mo.momz-frac, false)
				end
			end
		end
		
		if p.launched == true
			X_SpawnGhostTrail(p, frac/3, false)
		end
		
		// tail swipe or something
		/*if p.c1
		and P_IsObjectOnGround(p.mo)
			P_SetObjectMomZ(p.mo, 5*frac, false)
			S_StartSound(nil, sfx_zoom, p)
			P_NukeEnemies(p.mo, p.mo, 200*frac)
			p.mo.state = S_PLAY_SPRING
		end*/
		
		if P_IsObjectOnGround(p.mo)
			p.launched = false
		end
	end
end)

