local frac = FRACUNIT

// momentum things
local maxSpeed = 80*frac // need new max speed, domikoto showcase video showed me that you can gain way to much speed
local minSpeed = 20*frac // cuz we dont like being SLOW!
local momGain = frac-frac/11 // momentum gain
local baseFriction = frac // friction

addHook("PlayerSpawn", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) return end
		
		X_ResetPlayerVariables(p)
	end
end)

// RECODING TIME!!!!!!!!!!!!!!!!!!!!!!!
addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid) return end
		
		X_SetupPlayerVariables(p)
		
		if p.speed > minSpeed
			p.mo.friction = baseFriction
		else
			p.mo.friction = momGain
		end
		
		if p.speed > maxSpeed
			p.speed = maxSpeed
		end
		
		if (p.pflags & PF_THOKKED)
		and (p.pflags & PF_JUMPED)
		and not (p.charflags & SF_NOJUMPSPIN)
			X_SpawnThokTrail(p)
		end
		
		if not (p.cmd.buttons & BT_CUSTOM1) then
			p.c1ready = true
			p.c1 = false
		elseif p.c1ready then
			p.c1 = true
			p.c1ready = false
		else
			p.c1 = false
		end
		
		if not (p.cmd.buttons & BT_CUSTOM2) then
			p.c2ready = true
			p.c2 = false
		elseif p.c2ready then
			p.c2 = true
			p.c2ready = false
		else
			p.c2 = false
		end
		
		if not (p.cmd.buttons & BT_CUSTOM3) then
			p.c3ready = true
			p.c3 = false
		elseif p.c3ready then
			p.c3 = true
			p.c3ready = false
		else
			p.c3 = false
		end
		
		// reroll and unroll
		if not (p.charflags & SF_NOJUMPSPIN)
		and not p.nightstime
		and p.climbing == 0
			if not P_IsObjectOnGround(p.mo)
			and not P_PlayerInPain(p)
			and not (p.pflags & PF_JUMPED)
			and not (p.pflags & PF_THOKKED)
			and not (p.pflags & PF_SPINNING)
			and p.playerstate ~= PST_DEAD
			and p.c1
				p.pflags = $1|PF_JUMPED|PF_THOKKED
				p.mo.state = S_PLAY_ROLL
				S_StartSound(nil, sfx_rerol, p)
			end
			
			if P_IsObjectOnGround(p.mo)
			and (p.pflags & PF_SPINNING)
			and p.mo.state == S_PLAY_ROLL
			and p.c1
				p.pflags = $ & ~PF_SPINNING
				p.mo.state = S_PLAY_STND
				S_StartSound(nil, sfx_rerol, p)
			end
		end
		
		// run on water when going fast
		if not (skins[p.mo.skin].flags & SF_RUNONWATER)
			if p.speed > 50*frac
				p.charflags = $|SF_RUNONWATER
			else
				p.charflags = $ & ~SF_RUNONWATER
			end
		end
		
		// spin control
		if p.pflags & PF_SPINNING 
		and not (p.pflags & PF_STARTDASH) 
		and P_IsObjectOnGround(p.mo)
			p.thrustfactor = (skins[p.mo.skin].thrustfactor)*15
		else
			p.thrustfactor = skins[p.mo.skin].thrustfactor
		end
		
		// boost stuff
		if p.boostMechanic
			if p.speed > 20*frac or (p.pflags & PF_STARTDASH) or p.peelStart
				if (leveltime % 2 == 1)
					p.boostTime = $ + 1
				end
			else
				if P_IsObjectOnGround(p.mo)
					p.boostLevel = 0
					p.boostTime = 0
				end
			end
			
			if p.boostLevel > 0
				X_SpawnGhostTrailAdd(p, frac/4, true)
			end
			
			if p.boostTime > p.boostCap
				p.boostTime = p.boostCap
			end
			
			if (leveltime % 2 == 1)
				if p.boostTime == 20
					S_StartSound(p.mo, sfx_bost)
					p.boostLevel = 1
				end
				
				if p.boostTime == 40
					p.boostLevel = 2
				end
				
				if p.boostTime == 60
					S_StartSound(p.mo, sfx_bost2)
					p.boostLevel = 3
				end
				
				if p.boostTime == 80
					S_StartSound(p.mo, sfx_rerol)
					p.boostLevel = 4
				end
				
				if p.boostTime == 100
					S_StartSound(p.mo, sfx_bost3)
					S_StartSound(p.mo, sfx_peel)
					X_SpawnRingEffect(p)
					p.boostLevel = 5
				end
			end
			
			if p.boostLevel == 0
				p.normalspeed = skins[p.mo.skin].normalspeed
			end
			
			if p.boostLevel > 0 and p.boostLevel < 3
				p.normalspeed = skins[p.mo.skin].normalspeed * (6 / 5)
			end
			
			if p.boostLevel > 2 and p.boostLevel < 5
				p.normalspeed = skins[p.mo.skin].normalspeed * (3 / 2)
			end
			
			if p.boostLevel == 5
				p.normalspeed = skins[p.mo.skin].normalspeed * 2
				p.powers[pw_invulnerability] = 1
			end
			
			if not (skins[p.mo.skin].flags & SF_CANBUSTWALLS)
				if p.boostLevel >= 3
					p.charflags = $1|SF_CANBUSTWALLS
				else
					p.charflags = $ & ~SF_CANBUSTWALLS
				end
			end
			
			if (P_PlayerInPain(p) or p.mo.state == S_PLAY_PAIN)
				p.lostBoost = true
			else
				p.lostBoost = false
			end
			
			if p.lostBoost
			or p.playerstate == PST_DEAD
				p.boostLevel = 0
				p.boostTime = 0
			end
		end
	end
end)

addHook("TouchSpecial", function(mobj, pmo)
	if pmo.player.boostLevel >= 3 and (mobj.flags & MF_ENEMY)
		P_KillMobj(mobj, pmo, pmo)
		pmo.player.powers[pw_invulnerability] = 1
	end
end)

